#include <vector>
#include <map>
#include <iostream>
#include <algorithm>


class empl
{
public:
  int time, floor, id;

  empl(int time, int floor) : time(time), floor(floor)
  {
    static int i = 1;
    id = i++;
  }
};

void main(void)
{
  std::vector<empl> All;
  std::vector<empl> Active;
  std::vector<int> InLift;
  std::map<int, int> End;
  int dir = 0;
  int cur_time = 0;
  int cur_floor = 1;
  int n, m, t, f;

  std::cin >> n >> m;

  for (int i = 0; i < n; i++)
  {
    std::cin >> t >> f;
    All.push_back(empl(t, f));
  }

  //std::sort(All.begin(), All.end(), [=](empl A, empl B) { return A.id < B.id; });
  
  while (!(All.empty() && cur_floor == 1 && Active.empty() && InLift.empty()))
  {
    cur_time++;
    // checking for current active units
    for (auto i = All.begin(); i != All.end();)
      if (i->time == cur_time)
      {
        Active.push_back(*i);
        i = All.erase(i);
      }
      else
        ++i;

    
    // the beginning
    if (dir == 0 && !Active.empty())
    {
      dir = 1;
      continue;
    }
    // going upstairs
    if (dir == 1)
    {
      // if noone is waiting right now...
      if (Active.empty())
        continue;

      if (cur_floor != Active.begin()->floor)
        cur_floor++;
      if (cur_floor == Active.begin()->floor)
      {
        // putting people in the lift
        for (auto i = Active.begin(); i != Active.end();)
          if (i->floor == cur_floor)
          {
            InLift.push_back(i->id);
            i = Active.erase(i);
          }
          else
            ++i;
        dir = -1; // now going downstairs
        continue;
      }
    }
    // going downstairs
    else if (dir == -1)
    {
      if (cur_floor != 1)
        cur_floor--;
      
      // putting people in the lift while going downstairs
      for (auto i = Active.begin(); i != Active.end();)
        if (i->floor == cur_floor)
        {
          InLift.push_back(i->id);
          i = Active.erase(i);
        }
        else
          ++i;

      // save final results
      if (cur_floor == 1)
      {
        for (auto &i : InLift)
          End[i] = cur_time;
        InLift.clear();
        dir = 1;  
      }
    }
  }

  for (int i = 1; i <= n; i++)
    std::cout << End[i] << std::endl;
}